    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ------------------------
    028 * SimpleObjectFactory.java
    029 * ------------------------
    030 * (C)opyright 2003-2005, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: SimpleObjectFactory.java,v 1.3 2005/10/18 13:33:53 mungady Exp $
    036 *
    037 * Changes
    038 * -------
    039 * 02-Dec-2003 : Initial version
    040 *
    041 */
    042
    043package org.jfree.xml.util;
    044
    045import java.util.HashMap;
    046
    047/**
    048 * A simple object factory.
    049 */
    050public class SimpleObjectFactory implements ObjectFactory {
    051
    052    /** The object mappings. */
    053    private HashMap objectMappings;
    054
    055    /** The manual object mappings. */
    056    private HashMap manualMappings;
    057
    058    /** The multiplex mappings. */
    059    private HashMap multiplexMappings;
    060
    061    /**
    062     * Creates a new instance.
    063     */
    064    public SimpleObjectFactory() {
    065        this.objectMappings = new HashMap();
    066        this.manualMappings = new HashMap();
    067        this.multiplexMappings = new HashMap();
    068    }
    069
    070    /**
    071     * Adds a manual mapping.
    072     *
    073     * @param mapping  the mapping.
    074     */
    075    public void addManualMapping(final ManualMappingDefinition mapping) {
    076        this.manualMappings.put(mapping.getBaseClass(), mapping);
    077    }
    078
    079    /**
    080     * Adds a generic handler.
    081     *
    082     * @param handler  the handler.
    083     */
    084    public void addGenericHandler(final GenericObjectFactory handler) {
    085        this.objectMappings.put(handler.getBaseClass(), handler);
    086    }
    087
    088    /**
    089     * Adds a multiplex mapping.
    090     *
    091     * @param mplex  the multiplex mapping.
    092     */
    093    public void addMultiplexMapping(final MultiplexMappingDefinition mplex) {
    094        this.multiplexMappings.put(mplex.getBaseClass(), mplex);
    095    }
    096
    097    /**
    098     * Clears the mappings.
    099     */
    100    public void clear() {
    101        this.objectMappings.clear();
    102        this.manualMappings.clear();
    103        this.multiplexMappings.clear();
    104    }
    105
    106    /**
    107     * Returns a factory instance for the given class. The factory is independent
    108     * from all previously generated instances.
    109     *
    110     * @param c the class
    111     * @return the object factory.
    112     */
    113    public GenericObjectFactory getFactoryForClass(final Class c) {
    114        final GenericObjectFactory factory = (GenericObjectFactory) this.objectMappings.get(c);
    115        if (factory == null) {
    116            return null;
    117        }
    118        return factory.getInstance();
    119    }
    120
    121    /**
    122     * Returns the manual mapping definition for the given class, or null, if
    123     * not manual definition exists.
    124     *
    125     * @param c the class for which to check the existence of the definition
    126     * @return the manual mapping definition or null.
    127     */
    128    public ManualMappingDefinition getManualMappingDefinition(final Class c) {
    129        return (ManualMappingDefinition) this.manualMappings.get(c);
    130    }
    131
    132    /**
    133     * Returns the multiplex definition for the given class, or null, if no
    134     * such definition exists.
    135     *
    136     * @param c the class for which to check the existence of the multiplexer
    137     * @return the multiplexer for the class, or null if no multiplexer exists.
    138     */
    139    public MultiplexMappingDefinition getMultiplexDefinition(final Class c) {
    140        final MultiplexMappingDefinition definition = (MultiplexMappingDefinition)
    141        this.multiplexMappings.get(c);
    142        return definition;
    143    }
    144
    145    /**
    146     * Checks, whether a generic handler exists for the given class. This does
    147     * not check, whether an mapping exists.
    148     *
    149     * @param c the class for which to check
    150     * @return true, if an generic handler is defined, false otherwise.
    151     */
    152    public boolean isGenericHandler(final Class c) {
    153        return this.objectMappings.containsKey(c);
    154    }
    155}